/*----- PROTECTED REGION ID(Agilent33500BClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Agilent33500BClass.cpp
//
// description : C++ source for the Agilent33500BClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Agilent33500B once per process.
//
// project :     Agilent33500B
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "Agilent33500BClass.h"

/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass.cpp

//-------------------------------------------------------------------
/**
 *	Create Agilent33500BClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Agilent33500B_class(const char *name) {
		return Agilent33500B_ns::Agilent33500BClass::init(name);
	}
}

namespace Agilent33500B_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Agilent33500BClass *Agilent33500BClass::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
constexpr long WaveformAttrib::X_DATA_SIZE;
//--------------------------------------------------------
/**
 * method : 		Agilent33500BClass::Agilent33500BClass(std::string &s)
 * description : 	constructor for the Agilent33500BClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Agilent33500BClass::Agilent33500BClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering Agilent33500BClass constructor" << std::endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Agilent33500BClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::constructor

	TANGO_LOG_INFO << "Leaving Agilent33500BClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		Agilent33500BClass::~Agilent33500BClass()
 * description : 	destructor for the Agilent33500BClass
 */
//--------------------------------------------------------
Agilent33500BClass::~Agilent33500BClass()
{
	/*----- PROTECTED REGION ID(Agilent33500BClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Agilent33500BClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Agilent33500BClass *Agilent33500BClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new Agilent33500BClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Agilent33500BClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Agilent33500BClass *Agilent33500BClass::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetClass::execute(): arrived" << std::endl;
	((static_cast<Agilent33500B *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "OnClass::execute(): arrived" << std::endl;
	((static_cast<Agilent33500B *>(device))->on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "OffClass::execute(): arrived" << std::endl;
	((static_cast<Agilent33500B *>(device))->off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		LoadConfigurationFileClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *LoadConfigurationFileClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "LoadConfigurationFileClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<Agilent33500B *>(device))->load_configuration_file(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SaveConfigurationFileClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SaveConfigurationFileClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "SaveConfigurationFileClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<Agilent33500B *>(device))->save_configuration_file(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetConfigurationFilePathClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetConfigurationFilePathClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "GetConfigurationFilePathClass::execute(): arrived" << std::endl;
	return insert((static_cast<Agilent33500B *>(device))->get_configuration_file_path());
}

//--------------------------------------------------------
/**
 * method : 		SaveToFlashClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SaveToFlashClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "SaveToFlashClass::execute(): arrived" << std::endl;
	((static_cast<Agilent33500B *>(device))->save_to_flash());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ReLoadConfigurationFileClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReLoadConfigurationFileClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ReLoadConfigurationFileClass::execute(): arrived" << std::endl;
	((static_cast<Agilent33500B *>(device))->re_load_configuration_file());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent33500BClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent33500BClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent33500BClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Agilent33500BClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "IPAddress";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Output";
	prop_desc = "Output number (Start from 1)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Timeout";
	prop_desc = "Communication timeout (millisec)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "WaveformFile";
	prop_desc = "Name of the file where the waveform is stored";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ConfigFilePath";
	prop_desc = "Absolute path were config file are stored";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ConfigFile";
	prop_desc = "Configuration file";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "TrackModeSupport";
	prop_desc = "true if Track mode is supported";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SaveInternalConfig";
	prop_desc = "Save settings (if true) to internal reboot memory after \neach parameter change.";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void Agilent33500BClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("Agilent33500B");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("A class to control the Agilent 33500B waveform generator");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Agilent33500BClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Agilent33500BClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Agilent33500B(this, (*devlist_ptr)[i]));
	}

	// DO NOT CALL ERASE, conflict with Yat dyn attrs -> device crash!!!
	// erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Agilent33500B *dev = static_cast<Agilent33500B *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}
	return;	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new Agilent33500B(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Agilent33500B *dev = static_cast<Agilent33500B *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Agilent33500BClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Agilent33500BClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Agilent33500BClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::attribute_factory_before
	//	Attribute : Impedance
	ImpedanceAttrib	*impedance = new ImpedanceAttrib();
	Tango::UserDefaultAttrProp	impedance_prop;
	//	description	not set for Impedance
	//	label	not set for Impedance
	impedance_prop.set_unit("Ohm");
	//	standard_unit	not set for Impedance
	//	display_unit	not set for Impedance
	impedance_prop.set_format("%5.0f");
	//	max_value	not set for Impedance
	//	min_value	not set for Impedance
	//	max_alarm	not set for Impedance
	//	min_alarm	not set for Impedance
	//	max_warning	not set for Impedance
	//	min_warning	not set for Impedance
	//	delta_t	not set for Impedance
	//	delta_val	not set for Impedance
	impedance->set_default_properties(impedance_prop);
	//	Not Polled
	impedance->set_disp_level(Tango::OPERATOR);
	impedance->set_memorized();
	impedance->set_memorized_init(false);
	att_list.push_back(impedance);

	//	Attribute : Amplitude
	AmplitudeAttrib	*amplitude = new AmplitudeAttrib();
	Tango::UserDefaultAttrProp	amplitude_prop;
	//	description	not set for Amplitude
	//	label	not set for Amplitude
	amplitude_prop.set_unit("V");
	//	standard_unit	not set for Amplitude
	//	display_unit	not set for Amplitude
	amplitude_prop.set_format("%5.3f");
	//	max_value	not set for Amplitude
	//	min_value	not set for Amplitude
	//	max_alarm	not set for Amplitude
	//	min_alarm	not set for Amplitude
	//	max_warning	not set for Amplitude
	//	min_warning	not set for Amplitude
	//	delta_t	not set for Amplitude
	//	delta_val	not set for Amplitude
	amplitude->set_default_properties(amplitude_prop);
	//	Not Polled
	amplitude->set_disp_level(Tango::OPERATOR);
	amplitude->set_memorized();
	amplitude->set_memorized_init(false);
	att_list.push_back(amplitude);

	//	Attribute : Offset
	OffsetAttrib	*offset = new OffsetAttrib();
	Tango::UserDefaultAttrProp	offset_prop;
	//	description	not set for Offset
	//	label	not set for Offset
	offset_prop.set_unit("V");
	//	standard_unit	not set for Offset
	//	display_unit	not set for Offset
	offset_prop.set_format("%4.3f");
	//	max_value	not set for Offset
	//	min_value	not set for Offset
	//	max_alarm	not set for Offset
	//	min_alarm	not set for Offset
	//	max_warning	not set for Offset
	//	min_warning	not set for Offset
	//	delta_t	not set for Offset
	//	delta_val	not set for Offset
	offset->set_default_properties(offset_prop);
	//	Not Polled
	offset->set_disp_level(Tango::OPERATOR);
	offset->set_memorized();
	offset->set_memorized_init(false);
	att_list.push_back(offset);

	//	Attribute : SampleRate
	SampleRateAttrib	*samplerate = new SampleRateAttrib();
	Tango::UserDefaultAttrProp	samplerate_prop;
	//	description	not set for SampleRate
	//	label	not set for SampleRate
	samplerate_prop.set_unit("Sa/s");
	//	standard_unit	not set for SampleRate
	//	display_unit	not set for SampleRate
	samplerate_prop.set_format("%9.3f");
	//	max_value	not set for SampleRate
	//	min_value	not set for SampleRate
	//	max_alarm	not set for SampleRate
	//	min_alarm	not set for SampleRate
	//	max_warning	not set for SampleRate
	//	min_warning	not set for SampleRate
	//	delta_t	not set for SampleRate
	//	delta_val	not set for SampleRate
	samplerate->set_default_properties(samplerate_prop);
	//	Not Polled
	samplerate->set_disp_level(Tango::OPERATOR);
	samplerate->set_memorized();
	samplerate->set_memorized_init(false);
	att_list.push_back(samplerate);

	//	Attribute : TriggerMode
	TriggerModeAttrib	*triggermode = new TriggerModeAttrib();
	Tango::UserDefaultAttrProp	triggermode_prop;
	//	description	not set for TriggerMode
	//	label	not set for TriggerMode
	//	unit	not set for TriggerMode
	//	standard_unit	not set for TriggerMode
	//	display_unit	not set for TriggerMode
	//	format	not set for TriggerMode
	//	max_value	not set for TriggerMode
	//	min_value	not set for TriggerMode
	//	max_alarm	not set for TriggerMode
	//	min_alarm	not set for TriggerMode
	//	max_warning	not set for TriggerMode
	//	min_warning	not set for TriggerMode
	//	delta_t	not set for TriggerMode
	//	delta_val	not set for TriggerMode
	triggermode->set_default_properties(triggermode_prop);
	//	Not Polled
	triggermode->set_disp_level(Tango::OPERATOR);
	triggermode->set_memorized();
	triggermode->set_memorized_init(false);
	att_list.push_back(triggermode);

	//	Attribute : Triggering
	TriggeringAttrib	*triggering = new TriggeringAttrib();
	Tango::UserDefaultAttrProp	triggering_prop;
	//	description	not set for Triggering
	//	label	not set for Triggering
	//	unit	not set for Triggering
	//	standard_unit	not set for Triggering
	//	display_unit	not set for Triggering
	//	format	not set for Triggering
	//	max_value	not set for Triggering
	//	min_value	not set for Triggering
	//	max_alarm	not set for Triggering
	//	min_alarm	not set for Triggering
	//	max_warning	not set for Triggering
	//	min_warning	not set for Triggering
	//	delta_t	not set for Triggering
	//	delta_val	not set for Triggering
	triggering->set_default_properties(triggering_prop);
	//	Not Polled
	triggering->set_disp_level(Tango::OPERATOR);
	triggering->set_memorized();
	triggering->set_memorized_init(false);
	att_list.push_back(triggering);

	//	Attribute : Delay
	DelayAttrib	*delay = new DelayAttrib();
	Tango::UserDefaultAttrProp	delay_prop;
	//	description	not set for Delay
	//	label	not set for Delay
	delay_prop.set_unit("us");
	//	standard_unit	not set for Delay
	//	display_unit	not set for Delay
	delay_prop.set_format("%7.3f");
	//	max_value	not set for Delay
	//	min_value	not set for Delay
	//	max_alarm	not set for Delay
	//	min_alarm	not set for Delay
	//	max_warning	not set for Delay
	//	min_warning	not set for Delay
	//	delta_t	not set for Delay
	//	delta_val	not set for Delay
	delay->set_default_properties(delay_prop);
	//	Not Polled
	delay->set_disp_level(Tango::OPERATOR);
	delay->set_memorized();
	delay->set_memorized_init(false);
	att_list.push_back(delay);

	//	Attribute : TrackMode
	TrackModeAttrib	*trackmode = new TrackModeAttrib();
	Tango::UserDefaultAttrProp	trackmode_prop;
	//	description	not set for TrackMode
	//	label	not set for TrackMode
	//	unit	not set for TrackMode
	//	standard_unit	not set for TrackMode
	//	display_unit	not set for TrackMode
	//	format	not set for TrackMode
	//	max_value	not set for TrackMode
	//	min_value	not set for TrackMode
	//	max_alarm	not set for TrackMode
	//	min_alarm	not set for TrackMode
	//	max_warning	not set for TrackMode
	//	min_warning	not set for TrackMode
	//	delta_t	not set for TrackMode
	//	delta_val	not set for TrackMode
	trackmode->set_default_properties(trackmode_prop);
	//	Not Polled
	trackmode->set_disp_level(Tango::OPERATOR);
	trackmode->set_memorized();
	trackmode->set_memorized_init(false);
	att_list.push_back(trackmode);

	//	Attribute : BurstMode
	BurstModeAttrib	*burstmode = new BurstModeAttrib();
	Tango::UserDefaultAttrProp	burstmode_prop;
	//	description	not set for BurstMode
	//	label	not set for BurstMode
	//	unit	not set for BurstMode
	//	standard_unit	not set for BurstMode
	//	display_unit	not set for BurstMode
	//	format	not set for BurstMode
	//	max_value	not set for BurstMode
	//	min_value	not set for BurstMode
	//	max_alarm	not set for BurstMode
	//	min_alarm	not set for BurstMode
	//	max_warning	not set for BurstMode
	//	min_warning	not set for BurstMode
	//	delta_t	not set for BurstMode
	//	delta_val	not set for BurstMode
	burstmode->set_default_properties(burstmode_prop);
	//	Not Polled
	burstmode->set_disp_level(Tango::OPERATOR);
	burstmode->set_memorized();
	burstmode->set_memorized_init(false);
	att_list.push_back(burstmode);

	//	Attribute : BurstCycle
	BurstCycleAttrib	*burstcycle = new BurstCycleAttrib();
	Tango::UserDefaultAttrProp	burstcycle_prop;
	//	description	not set for BurstCycle
	//	label	not set for BurstCycle
	burstcycle_prop.set_unit("Cycles");
	//	standard_unit	not set for BurstCycle
	//	display_unit	not set for BurstCycle
	burstcycle_prop.set_format("%4d");
	//	max_value	not set for BurstCycle
	//	min_value	not set for BurstCycle
	//	max_alarm	not set for BurstCycle
	//	min_alarm	not set for BurstCycle
	//	max_warning	not set for BurstCycle
	//	min_warning	not set for BurstCycle
	//	delta_t	not set for BurstCycle
	//	delta_val	not set for BurstCycle
	burstcycle->set_default_properties(burstcycle_prop);
	//	Not Polled
	burstcycle->set_disp_level(Tango::OPERATOR);
	burstcycle->set_memorized();
	burstcycle->set_memorized_init(false);
	att_list.push_back(burstcycle);

	//	Attribute : BurstState
	BurstStateAttrib	*burststate = new BurstStateAttrib();
	Tango::UserDefaultAttrProp	burststate_prop;
	//	description	not set for BurstState
	//	label	not set for BurstState
	//	unit	not set for BurstState
	//	standard_unit	not set for BurstState
	//	display_unit	not set for BurstState
	//	format	not set for BurstState
	//	max_value	not set for BurstState
	//	min_value	not set for BurstState
	//	max_alarm	not set for BurstState
	//	min_alarm	not set for BurstState
	//	max_warning	not set for BurstState
	//	min_warning	not set for BurstState
	//	delta_t	not set for BurstState
	//	delta_val	not set for BurstState
	burststate->set_default_properties(burststate_prop);
	//	Not Polled
	burststate->set_disp_level(Tango::OPERATOR);
	burststate->set_memorized();
	burststate->set_memorized_init(false);
	att_list.push_back(burststate);

	//	Attribute : HighVoltage
	HighVoltageAttrib	*highvoltage = new HighVoltageAttrib();
	Tango::UserDefaultAttrProp	highvoltage_prop;
	//	description	not set for HighVoltage
	//	label	not set for HighVoltage
	//	unit	not set for HighVoltage
	//	standard_unit	not set for HighVoltage
	//	display_unit	not set for HighVoltage
	//	format	not set for HighVoltage
	//	max_value	not set for HighVoltage
	//	min_value	not set for HighVoltage
	//	max_alarm	not set for HighVoltage
	//	min_alarm	not set for HighVoltage
	//	max_warning	not set for HighVoltage
	//	min_warning	not set for HighVoltage
	//	delta_t	not set for HighVoltage
	//	delta_val	not set for HighVoltage
	highvoltage->set_default_properties(highvoltage_prop);
	//	Not Polled
	highvoltage->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(highvoltage);

	//	Attribute : LowVoltage
	LowVoltageAttrib	*lowvoltage = new LowVoltageAttrib();
	Tango::UserDefaultAttrProp	lowvoltage_prop;
	//	description	not set for LowVoltage
	//	label	not set for LowVoltage
	//	unit	not set for LowVoltage
	//	standard_unit	not set for LowVoltage
	//	display_unit	not set for LowVoltage
	//	format	not set for LowVoltage
	//	max_value	not set for LowVoltage
	//	min_value	not set for LowVoltage
	//	max_alarm	not set for LowVoltage
	//	min_alarm	not set for LowVoltage
	//	max_warning	not set for LowVoltage
	//	min_warning	not set for LowVoltage
	//	delta_t	not set for LowVoltage
	//	delta_val	not set for LowVoltage
	lowvoltage->set_default_properties(lowvoltage_prop);
	//	Not Polled
	lowvoltage->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(lowvoltage);

	//	Attribute : Configuration_File
	Configuration_FileAttrib	*configuration_file = new Configuration_FileAttrib();
	Tango::UserDefaultAttrProp	configuration_file_prop;
	//	description	not set for Configuration_File
	//	label	not set for Configuration_File
	//	unit	not set for Configuration_File
	//	standard_unit	not set for Configuration_File
	//	display_unit	not set for Configuration_File
	//	format	not set for Configuration_File
	//	max_value	not set for Configuration_File
	//	min_value	not set for Configuration_File
	//	max_alarm	not set for Configuration_File
	//	min_alarm	not set for Configuration_File
	//	max_warning	not set for Configuration_File
	//	min_warning	not set for Configuration_File
	//	delta_t	not set for Configuration_File
	//	delta_val	not set for Configuration_File
	configuration_file->set_default_properties(configuration_file_prop);
	//	Not Polled
	configuration_file->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(configuration_file);

	//	Attribute : Function
	FunctionAttrib	*function = new FunctionAttrib();
	Tango::UserDefaultAttrProp	function_prop;
	//	description	not set for Function
	//	label	not set for Function
	//	unit	not set for Function
	//	standard_unit	not set for Function
	//	display_unit	not set for Function
	//	format	not set for Function
	//	max_value	not set for Function
	//	min_value	not set for Function
	//	max_alarm	not set for Function
	//	min_alarm	not set for Function
	//	max_warning	not set for Function
	//	min_warning	not set for Function
	//	delta_t	not set for Function
	//	delta_val	not set for Function
	function->set_default_properties(function_prop);
	//	Not Polled
	function->set_disp_level(Tango::OPERATOR);
	function->set_memorized();
	function->set_memorized_init(false);
	att_list.push_back(function);

	//	Attribute : Frequency
	FrequencyAttrib	*frequency = new FrequencyAttrib();
	Tango::UserDefaultAttrProp	frequency_prop;
	//	description	not set for Frequency
	//	label	not set for Frequency
	frequency_prop.set_unit("Hz");
	//	standard_unit	not set for Frequency
	//	display_unit	not set for Frequency
	frequency_prop.set_format("%9.0f");
	//	max_value	not set for Frequency
	//	min_value	not set for Frequency
	//	max_alarm	not set for Frequency
	//	min_alarm	not set for Frequency
	//	max_warning	not set for Frequency
	//	min_warning	not set for Frequency
	//	delta_t	not set for Frequency
	//	delta_val	not set for Frequency
	frequency->set_default_properties(frequency_prop);
	//	Not Polled
	frequency->set_disp_level(Tango::OPERATOR);
	frequency->set_memorized();
	frequency->set_memorized_init(false);
	att_list.push_back(frequency);

	//	Attribute : NoiseBandwidth
	NoiseBandwidthAttrib	*noisebandwidth = new NoiseBandwidthAttrib();
	Tango::UserDefaultAttrProp	noisebandwidth_prop;
	//	description	not set for NoiseBandwidth
	//	label	not set for NoiseBandwidth
	noisebandwidth_prop.set_unit("Hz");
	//	standard_unit	not set for NoiseBandwidth
	//	display_unit	not set for NoiseBandwidth
	noisebandwidth_prop.set_format("%8.0f");
	//	max_value	not set for NoiseBandwidth
	//	min_value	not set for NoiseBandwidth
	//	max_alarm	not set for NoiseBandwidth
	//	min_alarm	not set for NoiseBandwidth
	//	max_warning	not set for NoiseBandwidth
	//	min_warning	not set for NoiseBandwidth
	//	delta_t	not set for NoiseBandwidth
	//	delta_val	not set for NoiseBandwidth
	noisebandwidth->set_default_properties(noisebandwidth_prop);
	//	Not Polled
	noisebandwidth->set_disp_level(Tango::OPERATOR);
	noisebandwidth->set_memorized();
	noisebandwidth->set_memorized_init(false);
	att_list.push_back(noisebandwidth);

	//	Attribute : OutputMode
	OutputModeAttrib	*outputmode = new OutputModeAttrib();
	Tango::UserDefaultAttrProp	outputmode_prop;
	outputmode_prop.set_description("0=> Normal\n1=> Gated (output activated by an external input)");
	//	label	not set for OutputMode
	//	unit	not set for OutputMode
	//	standard_unit	not set for OutputMode
	//	display_unit	not set for OutputMode
	//	format	not set for OutputMode
	//	max_value	not set for OutputMode
	//	min_value	not set for OutputMode
	//	max_alarm	not set for OutputMode
	//	min_alarm	not set for OutputMode
	//	max_warning	not set for OutputMode
	//	min_warning	not set for OutputMode
	//	delta_t	not set for OutputMode
	//	delta_val	not set for OutputMode
	outputmode->set_default_properties(outputmode_prop);
	//	Not Polled
	outputmode->set_disp_level(Tango::OPERATOR);
	outputmode->set_memorized();
	outputmode->set_memorized_init(false);
	att_list.push_back(outputmode);

	//	Attribute : WaveformFilter
	WaveformFilterAttrib	*waveformfilter = new WaveformFilterAttrib();
	Tango::UserDefaultAttrProp	waveformfilter_prop;
	waveformfilter_prop.set_description("0=>Normal\n1=>Step\n2=>OFF");
	//	label	not set for WaveformFilter
	//	unit	not set for WaveformFilter
	//	standard_unit	not set for WaveformFilter
	//	display_unit	not set for WaveformFilter
	//	format	not set for WaveformFilter
	//	max_value	not set for WaveformFilter
	//	min_value	not set for WaveformFilter
	//	max_alarm	not set for WaveformFilter
	//	min_alarm	not set for WaveformFilter
	//	max_warning	not set for WaveformFilter
	//	min_warning	not set for WaveformFilter
	//	delta_t	not set for WaveformFilter
	//	delta_val	not set for WaveformFilter
	waveformfilter->set_default_properties(waveformfilter_prop);
	//	Not Polled
	waveformfilter->set_disp_level(Tango::OPERATOR);
	waveformfilter->set_memorized();
	waveformfilter->set_memorized_init(false);
	att_list.push_back(waveformfilter);

	//	Attribute : Waveform
	WaveformAttrib	*waveform = new WaveformAttrib();
	Tango::UserDefaultAttrProp	waveform_prop;
	//	description	not set for Waveform
	//	label	not set for Waveform
	//	unit	not set for Waveform
	//	standard_unit	not set for Waveform
	//	display_unit	not set for Waveform
	//	format	not set for Waveform
	//	max_value	not set for Waveform
	//	min_value	not set for Waveform
	//	max_alarm	not set for Waveform
	//	min_alarm	not set for Waveform
	//	max_warning	not set for Waveform
	//	min_warning	not set for Waveform
	//	delta_t	not set for Waveform
	//	delta_val	not set for Waveform
	waveform->set_default_properties(waveform_prop);
	//	Not Polled
	waveform->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(waveform);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Agilent33500BClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Agilent33500BClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(Agilent33500BClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::pipe_factory_before
	/*----- PROTECTED REGION ID(Agilent33500BClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Agilent33500BClass::command_factory()
{
	/*----- PROTECTED REGION ID(Agilent33500BClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::command_factory_before

	//	Set polling perod for command State
	Tango::Command	&stateCmd = get_cmd_by_name("State");
	stateCmd.set_polling_period(1000);
	

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	//	Command Off
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);

	//	Command LoadConfigurationFile
	LoadConfigurationFileClass	*pLoadConfigurationFileCmd =
		new LoadConfigurationFileClass("LoadConfigurationFile",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Configuration file name (without the path)",
			"",
			Tango::OPERATOR);
	command_list.push_back(pLoadConfigurationFileCmd);

	//	Command SaveConfigurationFile
	SaveConfigurationFileClass	*pSaveConfigurationFileCmd =
		new SaveConfigurationFileClass("SaveConfigurationFile",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Configuration file name (without the path)",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSaveConfigurationFileCmd);

	//	Command GetConfigurationFilePath
	GetConfigurationFilePathClass	*pGetConfigurationFilePathCmd =
		new GetConfigurationFilePathClass("GetConfigurationFilePath",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"",
			"Configuration file path",
			Tango::OPERATOR);
	command_list.push_back(pGetConfigurationFilePathCmd);

	//	Command SaveToFlash
	SaveToFlashClass	*pSaveToFlashCmd =
		new SaveToFlashClass("SaveToFlash",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSaveToFlashCmd);

	//	Command ReLoadConfigurationFile
	ReLoadConfigurationFileClass	*pReLoadConfigurationFileCmd =
		new ReLoadConfigurationFileClass("ReLoadConfigurationFile",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pReLoadConfigurationFileCmd);

	/*----- PROTECTED REGION ID(Agilent33500BClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Agilent33500BClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void Agilent33500BClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		std::transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(Agilent33500BClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Agilent33500BClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Agilent33500BClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		Agilent33500B *dev = static_cast<Agilent33500B *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Agilent33500BClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500BClass::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Agilent33500BClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Agilent33500BClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::Additional Methods
} //	namespace
